;assembler debug example with NOICE for controller-board (www.frydaysoft.de)
;a) upload the NOICE-monitor (Mon8051.rom) to location 0x7000
;   - open Mon8051.asm in IDE51
;   - upload with 'upload'-button
;   - open dbg_leds.a51 in IDE51
;b) upload this test-application (use code at 0x0100)
;   - build binary file
;   - upload with 'upload'-button
;c) open NoIce-Debugger with serial protocol 19200baud
;d) do some changes in test-application
;e) go on with b)

$include (C:\ide51\inc\mod51)	;SFR-defines for 8031/51

NOICE_CODE equ 7000h			;used with Mon8051.a51

;-----------------------------------------------------------------------------
cseg at 0
USING 0
	org 0h
	jmp NOICE_CODE
	;  IE0 interrupt
	org    03h
		reti
	;  TF0 interrupt
	org    0Bh
		reti
	;  IE1 interrupt
	org    13h
		reti
	;  TF1 interrupt
	org    1Bh
		reti
	;  RI & TI interrupt
	org    23h
		reti
	;  TF2 & EXF2 interrupt
	org    2Bh
		reti
;-----------------------------------------------------------------------------
; User-application
org 0100h
start:  
	mov R0,#1h			; statup value

loop:
	mov a,R0			; prepare LED output on P4..7
	inc a
	mov R0,a			; save for next interation
	swap A				; use lower bits for LEDs
	orl a,#0fh			; set high for buttons on P0..3
	mov P1,a			; load value to port1
	call wait			; generate a delay
	call wait
	jmp loop			; do it again

;-----------------------------------------------------------------------------
wait:
	mov b,#0			; startup for outer delay loop
wait2:
	mov a,#0			; startup for internal delay loop
wait3:
	nop		
	nop
	nop
	djnz acc,wait3		; internal loop
	nop
	nop
	nop
	djnz b,wait2		; outher loop
	ret
end
