;example for the controller-board (www.frydaysoft.de)
;flash one Leds and put pressed KEY-Code to onboard-LEDs
;poll the HCT245 (input) and write this data to HCT574 (output)
;put text to LCD-display
;scan RS232 and write received data to LCD

$INCLUDE (C:\ide51\inc\mod51)
$INCLUDE (own_defs.INC)

;##################### MAIN Program #########################################

CSEG at 0
	;USING 3                 
	;USING 2                 
	;USING 1                 
	USING 0     		;Bank 0

ORG 0000h
JMP main_start			;jump to program

ORG 0003h               ;extInt0
RETI

ORG 000bh               ;timer0
RETI

ORG 0013h               ;extInt1
RETI

ORG 001Bh               ;timer1
RETI

ORG 0023h               ;RS232
RETI
;jmp SIO_INT

;**************************************************************************
main_start:
	MOV SP,  #Stack_First
	MOV DPTR,#0
	MOV ACC, #0
	MOV B,	 #0
	MOV PSW, #0
	MOV PCON,#0
	MOV SCON,#0
	MOV TCON,#0
	MOV TMOD,#0
	MOV IE,  #0
	MOV IP,  #0

	CLR step_walk
	SETB blink_cursor
	CALL lcd_init

	MOV DPTR,#LCD_TEXT			;write ROM-string to LCD
	SETB step_walk				;use single character delay output
	CALL lcdstring

	LCALL init_com         		;init RS232 with 9600 Baud 8N1
	MOV DPTR,#SIO_TEXT			;send ROM-string to RS232
	CALL send_const_text

	MOV P1,#0efh				;set Led4 on
	MOV A,#0					;position for LCD-cursor
	CALL setcursor				;set LCD-cursor
;call clearLCD		;clear LCD and cursor home
	CLR RI
	CLR TI

;################## Main - L O O P ########################

MainLoop:
	JB RI,ReadRx				;data over RS232 -> clr RI and read SBUF
	SJMP CheckPorts				;else scan inputs (Key/HC245)
ReadRx:
	MOV A,SBUF					;read rs232-buffer
	CLR RI						;clear flag for next rs232 event
	; do something with received byte ....
	CLR TI                  	;clear flag for transmission
	MOV SBUF,A					;transmit received data back (loop)
	JNB TI,$					;wait for transmit-completion
	CALL write_char				;write received byte to LCD
	SJMP MainLoop				

CheckPorts:
	MOV B,#HCT138_Y2			;read from HCT245
	CALL in_io
	CPL A
	MOV B,#HCT138_Y1			;write to HCT574
	CALL out_io
	CLR LED1					;write status of KEY1,2,3 to LED1,2,3
	JNB KEY1,ReadKey2
	SETB LED1
ReadKey2:
	CLR LED2
	JNB KEY2,ReadKey3	
	SETB LED2
ReadKey3:
	CLR LED3
	JNB KEY3,ReadKey4
	SETB LED3
ReadKey4:			
	JNB KEY4,Delay				;stop toggle-mode if KEY4 is pressed
	JNB LED4,SetLed4			;toggle LED4		
	CLR LED4
	SJMP Delay
SetLed4:
	SETB LED4	
Delay:
	CALL wait					;wait a little time
	SJMP MainLoop           	;nothings to do

;****************************************************************
$INCLUDE (waitloop.INC)
$INCLUDE (io_port.INC)
$INCLUDE (lcd.INC)
$INCLUDE (sio.INC)

LCD_EMPTY:     DB '                ',END_CH
LCD_TEXT:      DB 'FrydaySoft c2005',END_CH
SIO_TEXT:      DB 13,10,13,10,'FrydaySoft c2005',13,10,13,10,END_CH

END