;**** Bit-RAM 20..2F ****
 BSEG AT 02Fh					; use only last byte of BSEG-block for bit-variables
  blink_cursor: DBIT 1			; parameter for init_lcd
  step_walk:    DBIT 1  		; parameter for writeLCD_Array

 LCD_BUFMAX		EQU 10h
 LCD_BUFFER_END EQU LCD_BUFMAX+1
;**** Byte-RAM from 8h upto 2Dh ****
 DSEG AT 8h						; bank1..3 8..1Fh
  lcd_buffer:  DS LCD_BUFMAX	; string-buffer for LCD-Output
  unused_buf:  DS  8h			; 8 byte unused and BSEG not complete used
 DSEG AT 30h					; 30..7Fh
  STACK_RAM:   DS 50h			; **** reserved STACK-area  ****


;**** Hardware mapping ****
Key4   SET   P1.0
Key3   SET   P1.1
Key2   SET   P1.2
Key1   SET   P1.3
Led4   SET   P1.4
Led3   SET   P1.5
Led2   SET   P1.6
Led1   SET   P1.7

tmppointer	EQU R0
;R1..R7 not used

waitconst 		EQU   0h       	;const for wait-looping
Stack_First 	EQU  30h     	;set stackspointer to reserved RAM
; 9600 , XTAL=11,059MHz -> Timer=250=fah
baud 			EQU  250        ;timer1 -> baud=256-fosz/(Baud-rate*12*16)

;LCD-DDRAM-Adress
;Type			1. Line		2. Line
;1x8			0..7h
;1x16 (8+8)		0..7h & 40..47h
;1x16			0..Fh
;2x16			0..Fh			40..4Fh

;1x16
ADR_1LCD		EQU    0h		;define adr. of the 1. LCD-bank
ADR_12LCD		EQU    7h		;define next adr. out of the 1. LCD-bank
ADR_2LCD		EQU   40h		;define adr. of the 2. LCD-bank
ADR_22LCD		EQU   47h		;define next adr. out of the 2. LCD-bank

;2x16
;ADR_1LCD		EQU    0h		;define adr. of the 1. LCD-bank
;ADR_12LCD		EQU   10h		;define next adr. out of the 1. LCD-bank
;ADR_2LCD		EQU   40h		;define adr. of the 2. LCD-bank
;ADR_22LCD		EQU   50h		;define next adr. out of the 2. LCD-bank

END_CH 			EQU 0ffh		;end-definion for ROM-string

;***Pins of HCT138 (IC6)***********************************************************************
HCT138_Y1	EQU  10010000b
HCT138_Y2	EQU  10100000b
HCT138_Y3	EQU  10110000b
HCT138_Y4	EQU  11000000b
HCT138_Y5	EQU	 11010000b
HCT138_Y6	EQU  11100000b
HCT138_Y7	EQU  11110000b

;***map A1,0 to LCD-access*********************************************************************
LCD_RegWR 	EQU  80h       	;write lcd-register A0=0 ,A1=0
LCD_RegRD 	EQU  81h       	;read  lcd-register A0=1 ,A1=0
LCD_DataWR 	EQU  82h       	;write lcd-data	    A0=0 ,A1=0
LCD_DataRD 	EQU  83h       	;read  lcd-data	    A0=1 ,A1=0
