;small keyboard (12 keys decoded with 4 wires on P1.0-P1.3)
;--> schematic of keyboard-matrix see 12key.gif
;www.frydaysoft.de

;button positions
;-----------------
; S3  S6  S9
; S2  S5      S12
; S1      S8  S11
;     S4  S7  S10
;----------------

NO_KEY	equ 0Fh
S12	equ 0Bh
S11 equ 0Ah
S10 equ 09h
S9 	equ 08h
S8 	equ 07h
S7 	equ 06h
S6 	equ 05h
S5 	equ 04h
S4 	equ 03h
S3 	equ 02h
S2 	equ 01h
S1 	equ 00h


$INCLUDE (C:\ide51\inc\mod51)

OrMask		equ  00001111b
Key_Adr		equ  P1
P_Anz 		equ  4 				;lines of keyboard matrix

Stack_First	equ  40h

OldKey    	equ R7

Offset_Y1  	EQU 90h

cseg at 0
USING 3                 ;Bank 0
USING 2                 ;Bank 0
USING 1                 ;Bank 0
USING 0                 ;Bank 0

org 0000h
jmp main_start

org 0003h               ;extInt0
reti

org 000bh               ;timer0
reti

org 0013h               ;extInt1
reti

org 001Bh               ;T1
reti

org 0023h               ;sio
reti

main_start:
	mov SP,#Stack_First
	mov DPTR,	#0h
	mov acc,	#0h
	mov b,		#0h
	mov PSW,	#0h
	mov PCON,	#0h
	mov SCON,	#0h
	mov TCON,	#0h
	mov TMOD,	#0h
	mov IE,		#0h
	mov IP,		#0h
	mov OldKey,#NO_KEY
MainLoop:

	call GetKey
	jnc MainLoop
	mov b, a				;store readed key
	mov a,OldKey
	xrl a,b
	jz MainLoop				;key changed ?
	mov a,b
	mov OldKey,a
	mov b,#Offset_Y1
	call out_io				;put key-value to HC574
	swap a
	cpl a
	mov P1,a 				;put key-value to 4 onboard-LEDs
	jmp MainLoop

;--------------------------------------------
GetKey:
	push 0					;R0
	push 1					;R1
	push 2					;R2
	push 3					;R3
	push 4					;R4
	mov R0,#0FEh   			;init output-Mask
	mov R1,#0h				;init Key_Number
	mov R2,#P_Anz			;init column
GetKey1:
	mov R3,#1h     			;select first row
	mov R4,#P_Anz        	;number of rows
GetKey2:
	mov a,R2            	;compare column and row
	xrl a,R4				; --> do not read diagonal (same row/column)
	jz Diago
GetKeyAgain:
	mov a,Key_Adr 			;read keyport e.g. P1
	orl a,#OrMask        	;filter for output
	anl a,R0       			;set only Bits of Key_adr e.g. P1.0 - P1.3
	mov Key_Adr,a
	call shortwait										
	mov a,Key_Adr
	anl a,R3
	jz KeyPressed        	;NOTE: it's saver to read key 2x
GetKey4:
	inc R1					;check next Key
Diago:
	mov a,R3
	rl a                	;set next row
	mov R3,a
	djnz R4,GetKey2      	;is last Row
	mov a,R0
	rl a
	mov R0,a					;update output-Mask
	djnz R2,GetKey1     	;Spalten-loop
	jmp NoKey      
KeyPressed:
	mov a,OldKey
	xrl a,R1
	jnz KeyFound 
	clr c
	jmp KeyRet
NoKey:
	clr c
	mov a,#NO_KEY
	jmp KeyRet
KeyFound:
	setb c
	mov a,R1
KeyRet:
	pop 4					;R4
	pop 3					;R3
	pop 2					;R2
	pop 1					;R1
	pop 0					;R0
	ret             
;--------------------------------------------

shortwait:
	push acc
	mov a,#0
shortwait0:
	nop
	nop
	nop
	djnz acc,shortwait0
	pop acc
	ret
								
;--------------------------------------------
;in acc is data in b is IO-low-adresse
out_io:
	PUSH DPL
	PUSH DPH
	MOV DPL,#0
	MOV DPH,B
	MOVX @DPTR,A
	POP DPH
	POP DPL
	RET

END