;easy example for controller-board (www.frydaysoft.de)
;flash the 4 Leds 
;poll the HCT245 and put this data to HCT574
;blink frequency depends on buttons S4,3 or stop with S2

$INCLUDE (C:\ide51\inc\mod51)

CSEG at 0
USING 0
ORG 0000h
JMP start

; Highbyte A15..12 0 0 0 0
Offset_Y0  	EQU 80h
Offset_Y1  	EQU 90h		;HC574 out
Offset_Y2  	EQU 0a0h	;HC245 in
Offset_Y3  	EQU 0b0h
Offset_Y4  	EQU 0c0h
Offset_Y5	EQU 0d0h
Offset_Y6  	EQU 0e0h
Offset_Y7  	EQU 0f0h

ORG 0040h
start:  
	MOV SP,#30h	       ; Stackpointer to 30h
	MOV R0,#1h
;-----------------------------------------------------------------------------
loop:
	JNB P1.2,loop			;S2: do nothing if pressed douwn
	MOV A,R0
	INC A					;4bit value for LEDs
	ORL A,#0fh
	MOV R0,A
	CALL wait				;delay
	MOV P1,R0				;update LEDs
	MOV B,#Offset_Y2		;read HC245
	cpl a					;invert output for HC574
	CALL in_io
	MOV B,#Offset_Y1		;write value to HC574
	CALL out_io
	JNB P1.0,loop			;S4: for blink frequency
	CALL wait
	CALL wait
	CALL wait
	JNB P1.1,loop			;S3: for blink frequency
	CALL wait
	CALL wait
	CALL wait
	JMP loop				;default blink frequency

;-----------------------------------------------------------------------------
wait:
	MOV B,#80h
wait2:
	MOV A,#00h
	DJNZ ACC,$
	DJNZ B,wait2
	RET

;--------------------------------------------
;in acc is data in b is IO-low-adresse
out_io:
	PUSH DPL
	PUSH DPH
	MOV DPL,#0
	MOV DPH,B
	MOVX @DPTR,A
	POP DPH
	POP DPL
	RET

;--------------------------------------------
;in acc is data in b is IO-low-adresse
in_io:
	PUSH DPL
	PUSH DPH
	MOV DPL,#0
	MOV DPH,B
	MOVX A,@DPTR
	POP DPH
	POP DPL
	RET

;--------------------------------------------


END