//example for the controller-board (www.frydaysoft.de)
//write pattern to an external connected 82c55 (port expander)
//and to HC574 onboard latch
//load a time value from table for flexible time delay

#include "delay_ms.h"

//memory port of HC574
xdata at 0x9000 unsigned char hc574_chip;

//momory ports for external 82c55
xdata at 0x8000 unsigned char p82c55_port_a;
xdata at 0x8001 unsigned char p82c55_port_b;
xdata at 0x8002 unsigned char p82c55_port_c;
xdata at 0x8003 unsigned char p82c55_config;

#define VERBOSE

code unsigned char pattern_table[] = {
0x7F, /* 01111111 */
0x3F, /* 00111111 */
0x1F, /* 00011111 */
0x8F, /* 10001111 */
0xC7, /* 11000111 */
0xE3, /* 11100011 */
0xF1, /* 11110001 */
0xF8, /* 11111000 */
0xFC, /* 11111100 */
0xFE, /* 11111110 */
0xFC, /* 11111100 */
0xF8, /* 11111000 */
0xF1, /* 11110001 */
0xE3, /* 11100011 */
0xC7, /* 11000111 */
0x8F, /* 10001111 */
0x1F, /* 00011111 */
0x3F, /* 00111111 */
255};

code unsigned char delay_table[] = {
	90,70,50,40,40,40,40,50,70,90,70,50,40,40,40,40,50,70,0
};


unsigned char _sdcc_external_startup ()
{
    return 0;
}

void main()
{
	unsigned char i=0;
	unsigned char x=0;

	p82c55_config = 128;	// initialize all 82c55-ports as outputs

	while (1) 
	{
		if (delay_table[i] > 0)
		{
			p82c55_port_a = pattern_table[i];	//write pattern to portA
			hc574_chip = pattern_table[i];		//write pattern to onboard latch

			for (x=0; x<10; x++)
 			  delay_ms(delay_table[i]);			//delay from table
			i++;
		}
		 else 
		{
			i = 0;
		}
	}
}
