//example for the controller-board (www.frydaysoft.de)
//write pattern to an external connected 82c55 (port expander)
//and to HC574 onboard latch
//load a time value from table for flexible time delay
//this example runs with C-Pointern

#include "delay_ms.h"

//memory port of HC574
xdata at 0x9000 unsigned char hc574_chip;

//momory ports for external 82c55
xdata at 0x8000 unsigned char p82c55_port_a;
xdata at 0x8001 unsigned char p82c55_port_b;
xdata at 0x8002 unsigned char p82c55_port_c;
xdata at 0x8003 unsigned char p82c55_config;

#define VERBOSE

struct led_pattern_struct {
	unsigned char pattern;
	unsigned char delay;
};

code struct led_pattern_struct led_table[] = {
{0x7F, /* 01111111 */ 90},
{0xBF, /* 10111111 */ 80},
{0xDF, /* 11011111 */ 60},
{0xEF, /* 11101111 */ 50},
{0xF7, /* 11110111 */ 40},
{0xFB, /* 11111011 */ 30},
{0xFD, /* 11111101 */ 20},
{0xFE, /* 11111110 */ 30},
{0xFD, /* 11111101 */ 40},
{0xFB, /* 11111011 */ 50},
{0xF7, /* 11110111 */ 60},
{0xEF, /* 11101111 */ 70},
{0xDF, /* 11011111 */ 80},
{0xBF, /* 10111111 */ 90},
{255,0}};


unsigned char _sdcc_external_startup ()
{
    return 0;
}


void main()
{
	code struct led_pattern_struct *p=led_table;
	unsigned char x=0;

	p82c55_config = 128;	// initialize all 82c55-ports as outputs

	while (1) 
	{
		if (p->delay > 0) 
		{
			p82c55_port_a = p->pattern;	//write pattern to portA
			hc574_chip = p->pattern;	//write pattern to onboard latch

			for (x=0; x<10; x++)
 			 delay_ms(p->delay);		//delay from table
			p++;
		}
		 else 
		{
			p = led_table;
		}
	}
}


