// simple SIO-example 			www.frydaysoft.de
//example for the controller-board (www.frydaysoft.de)
//simple access to RS232 and LCD

#include "delay_ms.h"
#include "lcd_sio.h"

//memory port of HC574
xdata at 0x9000 unsigned char hc574_chip;

//onboard LEDs on Port0
sfr at 0x90 ledP1;						

//LCD-DDRAM-Adress
//Type			1. Line		2. Line
//1x8			0..7h
//1x16 (8+8)	0..7h & 40..47h
//1x16			0..Fh
//2x16			0..Fh			40..4Fh

//defines for display position for 1x16 LCD
#define Adr1 		0
#define Adr1Last 	0x8
#define Adr2 		0x40
#define Adr2Last 	0x48

//defines for display position for 2x16 LCD
/*
#define Adr1 		0
#define Adr1Last 	0x10
#define Adr2 		0x40
#define Adr2Last 	0x50
*/

#define divTimer 250		// timer1 -> divTimer=256-fosz/(Baud*12*16)

// init SIO for 9600 at 11.0592 MHz
unsigned char _sdcc_external_startup ()
{
	initCom(divTimer);
//	initLCD(0x38);			// 0x38 for 8bit-mode one line 5x7dots	
	initLCD(0x3C);			// 0x38 for 8bit-mode one line 5x7dots	
	
    return 0;
}

void main()
{
	unsigned char x=0x10,y=0;

	// print to terminal	
	newLine();
	puts("Hello Terminal\0");
	newLine();	


/*
	x=65;
	while(1)
	{
		charLCD(x);
		// wait about 1s
		for (y=0; y<10;y++)
		{
			delay_ms(100);
		}
		x++;
		y=getLCD_Cursor();
		if (y==Adr1Last)
		{
			setLCD_Cursor(Adr2);
		} 
		else
		{
			if (y==Adr2Last)
			{
				setLCD_Cursor(Adr1);
			}
		}
	}
*/
	// print to LCD
	charLCD('T');
	charLCD('e');
	charLCD('s');
	charLCD('t');
	charLCD(':');

	// loop forever
	while (1)
	{			
		//put data to OUTPUT (SL1)
		hc574_chip = ~x;		
		//put data to P1 (4 onboard-Leds)
		ledP1=~x;		
		
		// print to terminal
		puts("Pattern is: \0");
		putHex(x);
		puts("   \0");
		putBin(x);
		newLine();
		
		//shift bit
		x=x<<1;			
		
		//init bits again
		if(x==0) 
		{
			x=0x10;
		}
		
		// wait about 1s
		for (y=0; y<10;y++)
		{
			delay_ms(100);
		}
		
		y=getLCD_Cursor();
		if (y==Adr1Last)
		{
			setLCD_Cursor(Adr2);
		} 
		else
		{
			if (y==Adr2Last)
			{
				setLCD_Cursor(Adr1);
			}
		}
		charLCD(getLCD_Cursor()+0x24);
	}
}
