// simple SIO-example 			www.frydaysoft.de

#include "delay_ms.h"
#include "sio.h"

//memory port of HC574
xdata at 0x9000 unsigned char hc574_chip;

//onboard LEDs on Port0
sfr at 0x90 ledP1;

#define divTimer 250		// timer1 -> divTimer=256-fosz/(Baud*12*16)

// init SIO for 9600 at 11.0592 MHz
unsigned char _sdcc_external_startup ()
{
	_asm
	init_com:
		orl PCON,#0x80		; normal or faster processing
		orl SCON,#0x50		; SCON-Mode 1 (8Bit-UART) and REN 
		orl TCON,#0x40		; set TR1 ->use TIMER1 (xxx1xxxx)
		orl TMOD,#0x20		; set 8Bit-auto-reload-TIMER0  (00100000)
		mov TH1,#divTimer	; init Timer1 for Baud 9600 at 11.0592 MHz
		mov TL1,#divTimer
	
		setb SM2
		clr TF1
		setb TR1
		clr ET1
		clr RI        		
		clr PS		   		;lower priority
		setb ES
	_endasm;
    return 0;
}

void main()
{
	unsigned char x=0x10,y;

	// print to terminal	
	newLine();
	puts("Hello Terminal\0");
	newLine();	

	// loop forever
	while (1) 
	{
		//put data to OUTPUT (HC574)
		hc574_chip = ~x;		
		//put data to P1 (4 onboard-Leds)
		ledP1=~x;		
		
		// print to terminal
		puts("Pattern is: \0");
		putHex(x);
		puts("   \0");
		putBin(x);
		newLine();
		
		//shift bit
		x=x<<1;			
		
		//init bits again
		if(x==0) x=0x10;
		
		// wait about 1s
		for (y=0; y<10;y++)
		 delay_ms(100);
	}
}
